// pages/user/myworks/myworks.js
import APIClient from '../../../utils/APIClient.js'
import { formatDate } from '../../../utils/util.js'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    wareCards: {},
    pageNo: 1,
    totalNo: 0,
    uid: '',
    worksList: []
  },
  toMyWorks: function(e){
    let id = e.currentTarget.dataset.id;
    let title = e.currentTarget.dataset.title;
    wx.navigateTo({
      url: `../../social/works/works?id=${id}&title=${title}`
    });
  },
  getResults(){
    let pageNo = this.data.pageNo;
    let pageSize = 3;
    let uid = this.data.uid;
    console.log('用户身份',uid);
    APIClient.getUserMsg(uid, pageNo, pageSize).success(res => {
      this.setData({
        wareCards: res.data.data
      });
      wx.hideToast();
    }).fail(err => {
      console.log(err);
    });
    APIClient.userWorks(uid, pageNo, pageSize).success(res => {
      this.setData({
        worksList: res.data.data.list
      });
      wx.hideToast();
    }).fail(err => {
      console.log(err);
    });
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      uid: options.uid
    },() => {
      console.log(options.uid);
    });
    wx.showToast({
      title: '加载中...',
      icon: 'loading'
    });
    this.getResults();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    this.setData({
      pageNo: this.data.pageNo + 1
    })
    if (this.data.pageNo <= this.data.totalNo) {
      this.getResults();
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})